/*
 * output file framework for ARFF/XML/TEXT
 */

#ifndef OUTFILE_H
#define OUTFILE_H

#include <string>
#include <map>
#include <stdio.h>
#include <stdint.h>
using namespace std;

class outfile {
    string outfile_name;			// final output file
    FILE *tempfile;				// temporary file
public:
    outfile(const string &filename);
    virtual ~outfile(){};
    virtual bool needs_tempfile(){return false;}
    virtual void add_comment(const string &comment) = 0;
    virtual void add_value(const string &name,int64_t value) = 0;
    virtual void add_value(const string &name,const string &value) =0;
    virtual void add_valuet(const string &name,time_t t) = 0;
    virtual void new_row() = 0;
    virtual void write() = 0;
};

#endif
